#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "def_fun_glo.h"


int main(void)
{
		
	LCD_Initalize();		// inicjacja wywietlacza
	_delay_ms(100);
	timer0_init();
	KB_PORT;
	KRAW_POD;
	KB_PUL_UP;
	BUZ_SYR_KRAW_LED;
	sei()					;//	WCZENIE PRZERWA GLOBALNYCH


	unsigned char upperNibble, keyPressed, i;

//--EKRAN STARTOWY----------

	LCD_WriteText(" LADUNEK   ");
	LCD_GoTo(2,1);
	LCD_WriteText("   WYBUCHOWY ");
	_delay_ms(2000);

//---MENU GLOWNE-------------
	
	LCD_Clear();

	main_LCD();
	
	
//----------------------------	
	while(1)					// ptla gwna z obsug klawiatury
	{		upperNibble = 0xff;
		
		 for(i=0; i<4; i++)
		 {
		 	 _delay_ms(1);
			 KB_PORT_OUT = ~(0x01 << i);
			 _delay_ms(1);                    //Opnienie
			  
			  	upperNibble = KB_PORT_IN | 0x0f;
					
					if (upperNibble != 0xff)
					
					{ 	_delay_ms(20);                                //Opnienie  dla niwelacji drga
						 upperNibble = KB_PORT_IN | 0x0f;
						  if(upperNibble == 0xff) goto OUT;
							  
						  keyCode = (upperNibble & 0xf0) | (0x0f & ~(0x01 << i));
							  
						 while (upperNibble != 0xff)
						  upperNibble = KB_PORT_IN | 0x0f;
						  _delay_ms(20);                          //opnienie dla niwelacji drga
							   
							    switch (keyCode)                        //Znaki wywietlane na LCD
								 { 
								 	case (0xee): keyPressed = '1'; cyfra=1;pomoc++;  
									
									
									break;						
									
									case (0xed): keyPressed = '2'; cyfra=2; pomoc++; 
									break;									
									
									case (0xeb): keyPressed = '3'; cyfra=3; pomoc++; 
									break;									
									
									case (0xe7): keyPressed = 'A';
									break;

									case (0xde): keyPressed = '4'; cyfra=4; pomoc++; 
									break;									
									
									case (0xdd): keyPressed = '5'; cyfra=5; pomoc++;
									break;								
									
									case (0xdb): keyPressed = '6'; cyfra=6; pomoc++; 
									break;									
									
									case (0xd7): keyPressed = 'B';
									break;									
									
									case (0xbe): keyPressed = '7'; cyfra=7; pomoc++; 
									break;									
									
									case (0xbd): keyPressed = '8'; cyfra=8; pomoc++; 
									break;
																		
									case (0xbb): keyPressed = '9'; cyfra=9; pomoc++; 
									break;
																		
									case (0xb7): keyPressed = 'C';													     
									break;
																		
									case (0x7e): keyPressed = '*';
									break;									
									
									case (0x7d): keyPressed = '0'; cyfra=0; pomoc++; 
									break;																	
									
									case (0x7b): keyPressed = '#';
									break;					
																		
									case (0x77): keyPressed = 'D';
									break;								
									
									default    : keyPressed = 'X';
									break;
									
									
									}//Koniec klawiszy --
									if(LCD_klaw==true) LCD_WriteData(keyPressed); // zezwolenie na wysyanie do LCD
				
							StanMenu(); //menu i wybr trybw

							ZapisMinut(); //ustawianie minut

							UstKodu(); // ustawienie kodu

							RozbrojenieKodu(); //rozbrojenie bomby

								OUT:;


                }//koniec if-a 
	   }//koniec for-ki  
  
  	BL_RozEks(); // ustawienia brzeczyka i diody i syreny podczas rozbrojenia i eksplozji
	
	minutnik();
	
	kraw();		//obsuga czujnika zblienia
  
   	minutnik2();


  
  }//koniec while1 

}//a tu si koczy main()






//===========inicjacja przerwania=====================




void timer0_init(void)
{
	TCCR0 |= (1<<WGM01);    // TIMER0 tryb CTC
	TCCR0 |= (1<<CS02) | (1<<CS00);  // ustawienie preskalera
	OCR0 = 156;
	TIMSK |= (1<<OCIE0);

}




//---------------------------PROCEDURA OBSUGI PRZERWANIA------------

ISR(TIMER0_COMP_vect)
{
	static uint16_t licznik =1;
	
	licznik++;

	if(wpisKOD==1) LCD_GoTo(10,1);

	if( losowanie == 1 && licznik > 99) los = rand() % 2;
	
	if(licznik > 99 && SS_L==1 )
	{	SS_L2 = 1;  }
	
	if(licznik > 30 && SS_L==2 )
	{	SS_L2 = 1;  }
	
	if(pikacz==true)
	{
		if(licznik==25) LED_MRUG;
		if(licznik==49) LED_MRUG;
		if(licznik==25) BUZ_ON_OFF;
		if(licznik==49) BUZ_ON_OFF;

	}
	if(pikacz2==true)
	{
		if(licznik==25) LED_MRUG;
		if(licznik==49) LED_MRUG;
		if(licznik==25) BUZ_ON_OFF;
		if(licznik==49) BUZ_ON_OFF;
		
		if(licznik>49) licznik=1;

	

	}
	
	if(dzwiek == true){
		if(licznik==15) LED_MRUG;
		if(licznik==30) LED_MRUG;
		if(licznik==15) BUZ_ON_OFF;
		if(licznik==30) BUZ_ON_OFF;
		if(licznik==45) LED_MRUG;
		if(licznik==59) LED_MRUG;
		if(licznik==45) BUZ_ON_OFF;
		if(licznik==60) BUZ_ON_OFF;
	}
	
	if (licznik == 100) licznik = 0;
		
	

}
